Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
9e5689e5c187b0191e0ba7d9a921703f99168b5f
[simgrid.git] / src / smpi / smpirun.in
1 #! /bin/sh
2
3 # Copyright (c) 2007-2016, The SimGrid Team. All rights reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the license (GNU LGPL) which comes with this package.
7
8 @CMAKE_SMPI_COMMAND@
9
10 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
11 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
12
13 DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
14 DEFAULT_LOOPBACK_LATENCY="0.000004s"
15 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
16 DEFAULT_NETWORK_LATENCY="0.000005s"
17 DEFAULT_NUMPROCS="4"
18 DEFAULT_SPEED="100flops"
19
20 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
21 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
22 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
23 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
24 SPEED="${DEFAULT_SPEED}"
25
26 PRIVATIZE="--cfg=smpi/privatize-global-variables:yes"
27
28 SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP-gamma:4194304"
29
30 #usage to print the way this script should be called
31 usage () {
32     cat <<EOF
33 Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
34 Options:
35   -keep-temps                # don't remove the generated files after execution
36   -wrapper <command>         # use command to run the program (e.g. "valgrind")
37   -map                       # display the machine on which each process rank is mapped
38   -np <numprocs>             # use that amount of processes from the hostfile.
39                              # By default, all processes of the hostfile are used.
40   -no-privatize              # Disable the globals privatization, that is activated by default
41   -trace-ti                  # activate time independant tracing (for replay, default in smpi_simgrid.txt)
42   -trace                     # activate tracing (Paje, default in smpi_simgrid.trace)
43   -trace-comment <comment>   # put a comment on the top of the trace file
44   -trace-comment-file <file> # put file contents on the top of the trace file as comment
45   -trace-grouped             # group MPI processes by location
46   -trace-resource            # trace resource utilization
47   -trace-viva                # generate configuration for Viva's GraphView
48   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
49   -ext <value>               # additional parameter (reserved)
50
51   -version                   # Displays the SimGrid version (human readable)
52   -git-version               # Displays the git hash of SimGrid
53
54 or (deprecated usage):
55   $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
56
57 EOF
58 }
59
60 #check if we have at least one parameter
61 if [ $# -eq 0 ]
62 then
63     usage
64     exit
65 fi
66
67 EXTOPT=""
68 WRAPPER=""
69 HOSTFILE=""
70 HOSTFILETMP=0
71 MAPOPT=0
72 REPLAY=0
73
74 unset pid
75
76 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
77
78 smpirun_cleanup()
79 {
80   if [ -z "${KEEP}" ] ; then
81       if [ -z "${PLATFORM}" -a -n "$PLATFORMTMP" ]; then
82         rm -f ${PLATFORMTMP}
83         PLATFORMTMP=""
84       fi
85       if [ ${HOSTFILETMP} = 1 -a -n "$HOSTFILE" ] ; then
86           rm -f ${HOSTFILE}
87           HOSTFILE=""
88       fi
89       if [ ${UNROLLEDHOSTFILETMP} = 1 -a -n "$UNROLLEDHOSTFILE" ] ; then
90           rm -f ${UNROLLEDHOSTFILE}
91           UNROLLEDHOSTFILE=""
92       fi
93       if [ -n ${APPLICATIONTMP} ]; then
94         rm -f ${APPLICATIONTMP}
95         APPLICATIONTMP=""
96       fi
97   fi
98 }
99
100 smpirun_trap() {
101   local sig
102   sig="$1"
103
104   # Cleanup and kill the child process:
105   smpirun_cleanup
106   if ! [ -z "$pid" ]; then
107     kill -TERM $pid
108   fi
109   unset pid
110
111   # Raise the same signal again (remove the traps first):
112   trap - $trapped_signals
113   kill -$sig $$
114
115   # This should never happen:
116   kill -ABRT $$
117   kill -TERM $$
118 }
119
120 for s in $trapped_signals; do
121   trap "smpirun_trap $s" $s
122 done
123
124 while true; do
125     case "$1" in
126         "-np" | "-n")
127             NUMPROCS="$2"
128             shift 2
129             ;;
130         "-bandwidth")
131             NETWORK_BANDWIDTH="$2"
132             shift 2
133             ;;
134         "-latency")
135             NETWORK_LATENCY="$2"
136             shift 2
137             ;;
138         "-platform")
139             PLATFORM="$2"
140             if [ ! -f "${PLATFORM}" ]; then
141                 echo "[`basename $0`] ** error: the file '${PLATFORM}' does not exist. Aborting."
142                 exit 1
143             fi
144             shift 2
145             ;;
146         "-hostfile")
147             HOSTFILE="$2"
148             if [ ! -f "${HOSTFILE}" ]; then
149                 echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
150                 exit 1
151             fi
152             shift 2
153             ;;
154         "-machinefile")
155             HOSTFILE="$2"
156             if [ ! -f "${HOSTFILE}" ]; then
157                 echo "[`basename $0`] ** error: the file '${HOSTFILE}' does not exist. Aborting."
158                 exit 1
159             fi
160             shift 2
161             ;;
162         "-ext")
163             EXTOPT="$2"
164             shift 2
165             ;;
166         "-no-privatize")
167             PRIVATIZE=""
168             shift 1
169             ;;
170         "-map")
171             MAPOPT=1
172             shift 1
173             ;;
174         "-trace")
175             TRACE_ACTIVE="true"
176             shift 1
177             ;;
178         "-trace-ti")
179             TRACE_ACTIVE="true"
180             TRACE_TI_ACTIVE="true"
181             shift 1
182             ;;
183         "-trace-comment")
184             TRACE_COMMENT="$2"
185             shift 2
186             ;;
187         "-trace-comment-file")
188             TRACE_COMMENT_FILE="$2"
189             shift 2
190             ;;
191         "-trace-file")
192             TRACE_FILENAME="$2"
193             shift 2
194             ;;
195         "-trace-grouped")
196             TRACE_GROUPED="true"
197             shift 1
198             ;;
199         "-trace-resource")
200             TRACE_RESOURCE="true"
201             shift 1
202             ;;
203         "-trace-viva")
204             TRACE_VIVA="true"
205             shift 1
206             ;;
207         "-keep-temps")
208             KEEP="true"
209             shift 1
210             ;;
211         "-wrapper")
212             WRAPPER="$2"
213             shift 2
214             ;;
215         "-help" | "--help" | "-h")
216             usage
217             exit 0
218             ;;
219         "-version" | "--version" | "-v")
220             printf '%b\n' "$SIMGRID_VERSION"
221             exit 0
222             ;;
223         "-git-version" | "--git-version")
224             printf '%b\n' "$SIMGRID_GITHASH"
225             exit 0
226             ;;
227         "--cfg="*|"--log="*)
228             for OPT in ${1#*=}
229             do
230                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
231             done
232             shift 1
233             ;;
234         "-foreground")
235             # Nothing to do, compatibility.
236             shift 1
237             ;;
238         *)
239             break
240             ;;
241     esac
242 done
243
244 if [ -n "$WRAPPER" ]; then
245     EXEC="$WRAPPER $1"
246 else
247     EXEC="$1"
248 fi
249 shift
250
251 # steel --cfg and --logs options
252 while [ $# -gt 0 ]; do
253     case "$1" in
254         "--cfg="*|"--log="*)
255             for OPT in ${1#*=}
256             do
257                 SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
258             done
259             shift 1
260             ;;
261         *)
262             PROC_ARGS="${PROC_ARGS:+$PROC_ARGS }$1"
263             shift      
264             ;;
265     esac
266 done
267
268 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
269     echo "No hostfile nor platform specified."
270     usage
271     exit 1
272 fi
273
274 if [ -z "${HOSTFILE}" ] ; then
275     HOSTFILETMP=1
276     HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
277     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
278     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
279                 my ($pre,$rad,$post)=($1,$2,$3); 
280                 for my $elm (split(",",$rad)) { 
281                   if ($elm=~/^([^-]*?)-([^-]*)$/) { 
282                      for (my $i=$1; $i<=$2;$i++) { 
283                         print "$pre$i$post\n"; 
284                      }
285                   } else {
286                      print "$pre$elm$post\n";
287                   }
288                 }
289               } elsif (/<cluster/) {
290             die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
291               }' ${PLATFORM} >> ${HOSTFILE}
292 fi
293 UNROLLEDHOSTFILETMP=0
294
295 #parse if our lines are terminated by :num_process
296 multiple_processes=`grep -c ":" $HOSTFILE`
297 if [ "${multiple_processes}" -gt 0 ] ; then
298     UNROLLEDHOSTFILETMP=1
299     UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
300     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
301     if [ ${HOSTFILETMP} = 1 ] ; then
302         rm ${HOSTFILE}
303         HOSTFILETMP=0
304     fi
305     HOSTFILE=$UNROLLEDHOSTFILE
306 fi
307
308 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
309 hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
310 if [ ${hostfile_procs} = 0 ] ; then
311    echo "[`basename $0`] ** error: the hostfile '${HOSTFILE}' is empty. Aborting." >&2
312    exit 1
313 fi
314
315 if [ -z "${NUMPROCS}" ] ; then
316     # Use the amount of processes in the hostfile as default value for the -np parameter
317     NUMPROCS=$hostfile_procs
318 fi
319
320 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
321     echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
322 fi
323
324 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
325 if [ -z "${PLATFORM}" ]; then
326     PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
327
328     cat > ${PLATFORMTMP} <<PLATFORMHEAD
329 <?xml version='1.0'?>
330 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
331 <platform version="4">
332 <AS id="AS0" routing="Full">
333 PLATFORMHEAD
334
335     i=${NUMPROCS}
336     while [ $i -gt 0 ]; do
337         echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
338         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
339         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
340         i=$((i - 1))
341     done
342
343     i=${NUMPROCS}
344     while [ $i -gt 0 ]; do
345         j=${NUMPROCS}
346         while [ $j -gt 0 ]; do
347             if [ $i -eq $j ]; then
348                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
349             else
350                 echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
351             fi
352             j=$((j - 1))
353         done
354         i=$((i - 1))
355     done
356
357     cat >> ${PLATFORMTMP} <<PLATFORMFOOT
358 </AS>
359 </platform>
360 PLATFORMFOOT
361
362 else
363     PLATFORMTMP=${PLATFORM}
364 fi
365 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
366 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
367 APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
368 #APPLICATIONTMP="app.xml"
369
370 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
371 <?xml version='1.0'?>
372 <!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
373 <platform version="4">
374 APPLICATIONHEAD
375
376 ##---- cache hostnames of hostfile---------------
377 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
378     hostnames=$(cat ${HOSTFILE} | tr '\n\r' '  ')
379     NUMHOSTS=$(cat ${HOSTFILE} | wc -l)
380 fi
381
382 if [ "${EXTOPT}" = "smpi_replay" ]; then
383     APP_TRACES=$PROC_ARGS
384     if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
385         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
386         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
387         REPLAY=1
388     else
389         printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
390         exit 1
391     fi
392 fi
393
394 ##----------------------------------------------------------
395 ##  generate application.xml with hostnames from hostfile:
396 ##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
397 ##  hostfile has less than i lines.
398 ##----------------------------------------------------------
399
400 HAVE_SEQ="`which seq 2>/dev/null`"
401
402 if [ -n "${HAVE_SEQ}" ]; then
403     SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
404 else
405     cnt=0
406     while [ $cnt -lt ${NUMPROCS} ] ; do
407         SEQ="$SEQ $cnt"
408         cnt=$((cnt + 1));
409     done
410 fi
411
412 set -- $hostnames
413
414 ##---- generate <process> tags------------------------------
415 #prepare arguments at once
416 for ARG in $PROC_ARGS; do
417   XML_ARGS="${XML_ARGS}""<argument value=\"${ARG}\"/>
418 "
419 done
420
421 for i in ${SEQ}
422 do
423     j=$(( $i % ${NUMHOSTS} + 1 ))
424     host=$(eval "echo \${$j}")
425
426     ##---- optional display of ranks to process mapping
427     if [ ${MAPOPT} = 1 ]; then
428       echo "[rank $i] -> $host"
429     fi
430
431     echo "  <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->
432     <argument value=\"1\"/> <!-- instance -->
433     <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
434     if [ ${REPLAY} = 1 ]; then
435         if  [ ${NUMTRACES} -gt 1 ]; then
436             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f$j)\"/>" >> ${APPLICATIONTMP}
437         else
438             echo "    <argument value=\"$(echo $hosttraces|cut -d' ' -f1)\"/>" >> ${APPLICATIONTMP}
439         fi
440     else 
441     echo ${XML_ARGS} >> ${APPLICATIONTMP}
442     fi
443     echo "  </process>" >> ${APPLICATIONTMP}
444 done
445
446 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
447 </platform>
448 APPLICATIONFOOT
449 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
450 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
451 if [ -n "${TRACE_ACTIVE}" ]; then
452     #define trace filename
453     if [ -n "${TRACE_TI_ACTIVE}" ]; then
454         if [ -z "${TRACE_FILENAME}" ]; then
455             TRACE_FILENAME="smpi_simgrid.txt"
456         fi
457         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes --cfg=tracing/smpi/format:TI --cfg=tracing/smpi/computing:yes"
458     else
459         if [ -z "${TRACE_FILENAME}" ]; then
460             TRACE_FILENAME="smpi_simgrid.trace"
461         fi
462         TRACEOPTIONS="--cfg=tracing:yes --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:yes"
463     fi
464
465     if [ -n "${TRACE_COMMENT}" ]; then
466         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
467     fi
468
469     if [ -n "${TRACE_COMMENT_FILE}" ]; then
470         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
471     fi
472
473     if [ -n "${TRACE_GROUPED}" ]; then
474         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:yes"
475     fi
476
477     if [ -n "${TRACE_RESOURCE}" ]; then
478         TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:yes --cfg=tracing/uncategorized:yes"
479     fi
480
481     if [ -n "${TRACE_VIVA}" ]; then
482         TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
483     fi
484 fi
485 ##---------------------- end SMPI TRACING OPTIONS ---------------------------------
486
487 export SMPI_GLOBAL_SIZE=${NUMPROCS}
488 if [ -n "${KEEP}" ] ; then
489     echo ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PRIVATIZE} ${PLATFORMTMP} ${APPLICATIONTMP}
490     if [ ${HOSTFILETMP} = 1 ] ; then
491         echo "Generated hostfile ${HOSTFILE} kept."
492     fi
493     if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
494         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
495     fi
496 fi
497
498 # Execute the process
499 #
500 # The shell still need to be alive for the duration in order to do some cleanup after the process.
501 #
502 # We are going through great lengths in order to both keep stdin and be able to handle signals:
503 #
504 # * The job is launched in the background in order to be able to handle signals.
505 #
506 # * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
507 #   is launched in the background: this can be overriden in bash but not in standard bourne shell.
508 exec 3<&0
509 ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
510 pid=$!
511 exec 3>&-
512 wait $pid
513 status=$?
514 pid=""
515
516 # Keep temporary files on failures to help debugging
517 #
518 if [ ${status} -ne 0 ] ; then
519     if [ -z ${KEEP} ]; then
520         echo ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PRIVATIZE} ${PLATFORMTMP} ${APPLICATIONTMP}
521         if [ ${HOSTFILETMP} = 1 ] ; then
522             echo "Generated hostfile ${HOSTFILE} kept."
523         fi
524         if [ ${UNROLLEDHOSTFILETMP} = 1 ] ; then
525             echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept."
526         fi
527     fi
528     echo "Execution failed with code ${status}."
529     KEEP=true
530 fi
531
532 smpirun_cleanup
533
534 exit $status